/* 
   $Id: sgdate_main.c,v 1.4 2002/06/06 07:28:22 shibajun Exp $

   Copyright (C) 2001,2002 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of sgdate.

   sgdate is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   sgdate is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with sgdate; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include <X11/X.h>

#define  ENABLE_NLS 1
#include <gnome.h>

#define check_hour(X) (X >= 0 && X < 24)
#define check_min(X)  (X >= 0 && X < 60)
#define check_sec(X)  (X >= 0 && X < 60)

#include <config.h>

GtkWidget *date_label;
GtkWidget *cal;
GtkWidget *time_entry, *time_label;
GtkWidget *table;
GtkWidget *hour_combo, *min_combo, *sec_combo;

GtkWidget *update_btn;
GtkWidget *quit_btn;
GList     *hours, *mins;

int timer = 0;

void set_time(gpointer data)
{
  char s[256];
  struct tm *tm;
  time_t    t;
  
  time(&t);
  tm = localtime(&t);
  sprintf(s, "%2d", tm->tm_hour);
  gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(hour_combo)->entry), s);

  sprintf(s, "%2d", tm->tm_min);
  gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(min_combo)->entry), s);

  sprintf(s, "%2d", tm->tm_sec);
  gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(sec_combo)->entry), s);
}

void quit(GtkWidget *widget, GdkEvent *event, gpointer data)
{
  gtk_main_quit();
}

void timer_stop(GtkWidget *widget, GdkEvent *event, gpointer data)
{
  gtk_timeout_remove(timer);
}

void update_button(GtkWidget *widget, GdkEvent *event, gpointer data)
{
  char *hour_p, *min_p, *sec_p;
  int  hour, min, sec;
  int  year, month, day;
  char s[256];

  gtk_timeout_remove(timer);

  gtk_calendar_get_date(GTK_CALENDAR(cal), &year, &month, &day);

  hour_p = gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(hour_combo)->entry));
  min_p = gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(min_combo)->entry));
  sec_p = gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(sec_combo)->entry));
  
  hour = atoi(hour_p);
  min  = atoi(min_p);
  sec  = atoi(sec_p);    
    
  if(check_hour(hour) && check_min(min) && check_min(sec)){

#ifdef __FreeBSD__    
    sprintf(s, "date %4d%02d%02d%02d%02d.%02d >/dev/null",
	    year, month+1, day, hour, min, sec);
#else
    sprintf(s, "date %02d%02d%02d%02d%4d.%02d >/dev/null",
	    month+1, day, hour, min, year, sec);
#endif

    system(s);
    system("xset s reset");
    
    timer = gtk_timeout_add(250, (GtkFunction) set_time, 0);    
  }

}

void init_entrys(GtkWidget *app)
{
  struct tm *tm;
  time_t    t;
  int       i;
  char      s[256];
  
  table = gtk_table_new(5, 3, FALSE);

  date_label = gtk_label_new(_("Date"));
  cal  = gtk_calendar_new();

  time_label = gtk_label_new(_("Time"));

  hours = NULL;
  for(i = 0; i < 24; i++){
    sprintf(s, "%2d", i);
    hours = g_list_append(hours, strdup(s));
  }

  mins = NULL;
  for(i = 0; i < 60; i++){
    sprintf(s, "%2d", i);
    mins = g_list_append(mins, strdup(s));
  }

  hour_combo = gtk_combo_new();
  gtk_combo_set_popdown_strings(GTK_COMBO(hour_combo), hours);
  gtk_widget_set_usize(hour_combo, 56, -1);
  gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(hour_combo)->entry), FALSE);

  min_combo = gtk_combo_new();
  gtk_combo_set_popdown_strings(GTK_COMBO(min_combo), mins);
  gtk_widget_set_usize(min_combo, 42, -1);
  gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(min_combo)->entry), FALSE);

  sec_combo = gtk_combo_new();
  gtk_combo_set_popdown_strings(GTK_COMBO(sec_combo), mins);
  gtk_widget_set_usize(sec_combo, 42, -1);
  gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(sec_combo)->entry), FALSE);

  update_btn = gtk_button_new_with_label(_("Update"));
  quit_btn   = gtk_button_new_with_label(_("Quit"));

  gtk_table_attach(GTK_TABLE(table), date_label, 0, 3, 2, 3,
		   GTK_FILL|GTK_EXPAND, GTK_FILL|GTK_EXPAND, 0, 0);

  gtk_table_attach(GTK_TABLE(table), cal, 0, 3, 3, 4,
		   GTK_FILL|GTK_EXPAND, GTK_FILL|GTK_EXPAND, 0, 0);

  gtk_table_attach(GTK_TABLE(table), time_label, 0, 3, 0, 1,
		   GTK_FILL|GTK_EXPAND, GTK_FILL|GTK_EXPAND, 0, 0);

  gtk_table_attach(GTK_TABLE(table), hour_combo, 0, 1, 1, 2,
		   GTK_FILL|GTK_EXPAND, GTK_FILL|GTK_EXPAND|GTK_SHRINK, 0, 0);
  gtk_table_attach(GTK_TABLE(table), min_combo, 1, 2, 1, 2,
		   GTK_FILL|GTK_EXPAND, GTK_FILL|GTK_EXPAND|GTK_SHRINK, 0, 0);
  gtk_table_attach(GTK_TABLE(table), sec_combo, 2, 3, 1, 2,
		   GTK_FILL|GTK_EXPAND, GTK_FILL|GTK_EXPAND|GTK_SHRINK, 0, 0);

  gtk_table_attach(GTK_TABLE(table), update_btn, 0, 1, 4, 5,
		   GTK_FILL|GTK_EXPAND, GTK_FILL|GTK_EXPAND|GTK_SHRINK, 0, 0);

  gtk_table_attach(GTK_TABLE(table), quit_btn, 2, 3, 4, 5,
		   GTK_FILL|GTK_EXPAND, GTK_FILL|GTK_EXPAND, 0, 0);

  gtk_signal_connect(GTK_OBJECT(GTK_COMBO(hour_combo)->entry),
		     "focus_in_event",
		     GTK_SIGNAL_FUNC(timer_stop), NULL);

  gtk_signal_connect(GTK_OBJECT(GTK_COMBO(min_combo)->entry),
		     "focus_in_event",
		     GTK_SIGNAL_FUNC(timer_stop), NULL);

  gtk_signal_connect(GTK_OBJECT(GTK_COMBO(sec_combo)->entry),
		     "focus_in_event",
		     GTK_SIGNAL_FUNC(timer_stop), NULL);

  gtk_signal_connect(GTK_OBJECT(update_btn), "clicked",
		     GTK_SIGNAL_FUNC(update_button), NULL);

  gtk_signal_connect(GTK_OBJECT(quit_btn), "clicked",
		     GTK_SIGNAL_FUNC(quit), NULL);

  time(&t);
  tm = localtime(&t);

  gtk_calendar_select_month(GTK_CALENDAR(cal), tm->tm_mon, tm->tm_year + 1900);
  gtk_calendar_select_day(GTK_CALENDAR(cal), tm->tm_mday);
  
  set_time(0);
  gnome_app_set_contents(GNOME_APP(app), table);
}


int main(int argc, char **argv)
{
  GtkWidget *app;

  bindtextdomain(PACKAGE, PACKAGE_LOCALE_DIR);
  textdomain(PACKAGE);

  gtk_set_locale();

  gnome_init (PACKAGE, VERSION, argc, argv);
  app = gnome_app_new("sgdate", "sgdate");

  gtk_signal_connect (GTK_OBJECT (app), "delete_event",
		      GTK_SIGNAL_FUNC (quit), NULL);

  init_entrys(app);

  gtk_widget_show_all(app);

  timer = gtk_timeout_add(250, (GtkFunction) set_time, 0);
  gtk_main();

  return 1;
}
